EEL_Stat = {
	 [0] = _G["ALL"],
	 [1] = _G["ITEM_MOD_STAMINA_SHORT"],
	 [2] = _G["ITEM_MOD_INTELLECT_SHORT"],
	 [3] = _G["ITEM_MOD_SPIRIT_SHORT"],
	 [4] = _G["ITEM_MOD_STRENGTH_SHORT"],
	 [5] = _G["ITEM_MOD_HASTE_RATING_SHORT"],
	 [6] = _G["ITEM_MOD_AGILITY_SHORT"],
	 [7] = _G["ITEM_MOD_HIT_RATING_SHORT"],
	 [8] = _G["ITEM_MOD_CRIT_RATING_SHORT"],
	 [9] = _G["ITEM_MOD_MASTERY_RATING_SHORT"],
	[10] = _G["ITEM_MOD_DODGE_RATING_SHORT"],
	[11] = _G["ITEM_MOD_PARRY_RATING_SHORT"],
	[12] = _G["ITEM_MOD_EXPERTISE_RATING_SHORT"],
	[13] = _G["ITEM_MOD_BLOCK_RATING_SHORT"],
	[14] = _G["ITEM_MOD_RESILIENCE_RATING_SHORT"],
	[15] = _G["ITEM_MOD_SPELL_POWER_SHORT"],
	[16] = _G["ITEM_MOD_SPELL_PENETRATION_SHORT"],
	[17] = _G["ARMOR"],
	[18] = EEL_LocaleText["allstats"]
}

EEL_Slot = {
	[0] = _G["ALL"],
	[1] = _G["INVTYPE_CHEST"],
    [2] = _G["INVTYPE_CLOAK"],
    [3] = _G["INVTYPE_WRIST"],
    [4] = _G["INVTYPE_HAND"],
    [5] = _G["INVTYPE_FEET"],
    [6] = _G["INVTYPE_FINGER"],
    [7] = _G["INVTYPE_WEAPON"],
    [8] = _G["TWO_HANDED"],
    [9] = _G["INVTYPE_SHIELD"],
}


EEL_Level = {
	[0] = _G["ALL"],
	[1] = "Classic",
	[2] = "BC",
	[3] = "WotLK",
	[4] = "Cataclysm"
}

EEL_Op = {
	[0] = "=",
	[1] = ">=",
	[2] = "<="
}


-- DETAILS CHECKBUTTON ------------------------------------------------

function EEL_CheckButtonDetails_OnClick(this)
	local i;
	if CheckButtonDetails:GetChecked() then
		EEL_Options["details"] = true;
	else 
		EEL_Options["details"] = false;
	end
	for i = 1, 15 do
		item = _G["EELItem_"..i];
		item:Hide();
	end
	EEL_ScrollBar_Update();
end

-- SLOT DROPDOWN ------------------------------------------------

function EEL_SlotDropDown_Init()
	local entries = table.getn(EEL_Slot);
	for i=0,entries do
		info = {};
		value = i;
		text = EEL_Slot[i];
		info.value = value;
		info.text = text;
		info.func = EEL_SlotDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EEL_SlotDropDown_OnShow()
    UIDropDownMenu_Initialize(EEL_SlotDropDown, EEL_SlotDropDown_Init);
    UIDropDownMenu_SetSelectedID(EEL_SlotDropDown, EEL_Options["SelectedSlot"]+1);
    UIDropDownMenu_SetWidth(EEL_SlotDropDown, 150);
    EEL_ScrollBar_Update();
end

function EEL_SlotDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EEL_SlotDropDown, i);
    EEL_Options["SelectedSlot"] = i-1;
    EEL_ScrollBar_Update();
end

-- STAT DROPDOWN ------------------------------------------------

function EEL_StatDropDown_Init()
	local entries = table.getn(EEL_Stat);
	for i=0,entries do
		info = {};
		value = i;
		text = EEL_Stat[i];
		info.text = text;
		info.value = value;
		info.func = EEL_StatDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EEL_StatDropDown_OnShow()
    UIDropDownMenu_Initialize(EEL_StatDropDown, EEL_StatDropDown_Init);
    UIDropDownMenu_SetSelectedID(EEL_StatDropDown, EEL_Options["SelectedStat"]+1);
    UIDropDownMenu_SetWidth(EEL_StatDropDown, 150);
    EEL_ScrollBar_Update();
end

function EEL_StatDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EEL_StatDropDown, i);
    EEL_Options["SelectedStat"] = i-1;
    EEL_ScrollBar_Update();
end



-- LEVEL OP ------------------------------------------------

function EEL_LevelOp_Init()
	local entries = table.getn(EEL_Op);
	for i=0,entries do
		info = {};
		value = i;
		text = EEL_Op[i];
		info.value = value;
		info.text = text;
		info.func = EEL_LevelOp_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EEL_LevelOp_OnShow()
    UIDropDownMenu_Initialize(EEL_LevelOp, EEL_LevelOp_Init);
    UIDropDownMenu_SetSelectedID(EEL_LevelOp, EEL_Options["SelectedLevelOp"]+1);
    UIDropDownMenu_SetWidth(EEL_LevelOp, 40);
    EEL_ScrollBar_Update();
end

function EEL_LevelOp_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EEL_LevelOp, i);
    EEL_Options["SelectedLevelOp"] = i-1;
    EEL_ScrollBar_Update();
end

-- ITEMLEVEL DROPDOWN ------------------------------------------------

function EEL_LevelDropDown_Init()
	local entries = table.getn(EEL_Level);
	if (EEL_Options["cataclysm"] == false) then
		entries = entries - 1;
	end
	for i=0,entries do
		info = {};
		value = i;
		text = EEL_Level[i];
		info.text = text;
		info.value = value;
		info.func = EEL_LevelDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EEL_LevelDropDown_OnShow()
    UIDropDownMenu_Initialize(EEL_LevelDropDown, EEL_LevelDropDown_Init);
    UIDropDownMenu_SetSelectedID(EEL_LevelDropDown, EEL_Options["SelectedLevel"]+1);
    UIDropDownMenu_SetWidth(EEL_LevelDropDown, 80);
    EEL_ScrollBar_Update();
end

function EEL_LevelDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EEL_LevelDropDown, i);
    EEL_Options["SelectedLevel"] = i-1;
    EEL_ScrollBar_Update();
end

-- CLASS & SPEC DROPDOWN ------------------------------------------------

function EEL_SpecSort(a,b)
	local _, class = UnitClass("player");
	local ssl = EEL_SSL;
	-- put ALL on top
	if (ssl[a]["classid"] == -1) then
		return true;
	end
	if (ssl[b]["classid"] == -1) then
		return false;
	end
	-- sort Class and Spec by localized names and put own class on top
	if (ssl[a]["classname"] == class) and (ssl[b]["classname"] == class) then
		if ssl[a]["localname"] > ssl[b]["localname"] then
			return true;
		else
			return false;
		end
	elseif ssl[a]["classname"] == class then
		return true;
	elseif ssl[b]["classname"] == class then
		return false;
	elseif ssl[a]["localname"] > ssl[b]["localname"] then
		return true;
	else
		return false;
	end
end


function EEL_SpecDropDown_Init()
	local entries = table.getn(EEL_CR);
	local _, class = UnitClass("player");
	cid = 1;
	EEL_SSL = {};
	EEL_SSL[0] = {};
	EEL_SSL[0]["classid"] = -1;
	EEL_SSL[0]["classname"] = "AAA";
	EEL_SSL[0]["localname"] = _G["ALL"];
	for i=0,entries do
		local specentries = table.getn(EEL_CR[i]);
		if specentries > 0 then
			for j=1,specentries do
				local temp = {};
				temp["classid"] = i;
				temp["classname"] = EEL_CR[i][0];
				temp["specid"] = j;
				temp["hint"] = EEL_CR[i][j][3];
				if specentries > 1 then
					-- Class and Spec
					temp["localname"] = EEL_ClassNames[i].." ("..EEL_SpecNames[EEL_CR[i][j][0]]..")";
				else
					-- Only Class (just one spec)
					temp["localname"] = EEL_ClassNames[i];
				end
				table.insert(EEL_SSL,cid,temp);
				cid = cid + 1;
			end
		end
	end
	-- Sort Spec List
	-- table.sort(EEL_SSL, EEL_SpecSort);
	local entries = table.getn(EEL_SSL);
	for i=0,entries do
		info = {};
		value = {};
		if EEL_SSL[i]["classname"] == class then
			text = _G["ITEM_QUALITY_COLORS"][2].hex..EEL_SSL[i]["localname"];
		else
			text = EEL_SSL[i]["localname"];
		end
		info.text = text;
		info.value = value;
		info.func = EEL_SpecDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EEL_SpecDropDown_OnShow()
    UIDropDownMenu_Initialize(EEL_SpecDropDown, EEL_SpecDropDown_Init);
    UIDropDownMenu_SetSelectedID(EEL_SpecDropDown, EEL_Options["SelectedSpec"]+1);
    UIDropDownMenu_SetWidth(EEL_SpecDropDown, 150);
	if EEL_Options["SelectedSpec"] > 0 then
		egl_hint = _G["EEL_HINT"];
		if EEL_SSL[EEL_Options["SelectedSpec"]]["hint"] ~= nil then
			egl_hint:SetText(EEL_SSL[EEL_Options["SelectedSpec"]]["hint"]);
		else
			egl_hint:SetText("");
		end
	end
    EEL_ScrollBar_Update();
end

function EEL_SpecDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EEL_SpecDropDown, i);
    EEL_Options["SelectedSpec"] = i-1;
	if EEL_Options["SelectedSpec"] > 0 then
		egl_hint = _G["EEL_HINT"];
		if EEL_SSL[EEL_Options["SelectedSpec"]]["hint"] ~= nil then
			egl_hint:SetText(EEL_SSL[EEL_Options["SelectedSpec"]]["hint"]);
		else
			egl_hint:SetText("");
		end
	else
		egl_hint:SetText("");
	end
    EEL_ScrollBar_Update();
end
